﻿
Imports System.Windows.Forms
Imports System.Runtime.InteropServices
Imports Infragistics.Win.UltraWinGrid



Public Class Form1

#Region "Windows Clipboard API"


    Private m_CBData As IntPtr
    Dim strToCopy As String = "Hello"

    Public Const GMEM_DDESHARE As UInteger = &H2000
    Public Const CF_TEXT As UInteger = 1


    <DllImport("user32.dll", SetLastError:=True)> _
    Public Shared Function OpenClipboard(ByVal hWndNewOwner As IntPtr) As Boolean
    End Function


    <DllImport("user32.dll", SetLastError:=True)> _
    Public Shared Function GetClipboardData(ByVal uFormat As UInteger) As IntPtr
    End Function

    <DllImport("kernel32.dll", SetLastError:=True)> _
    Public Shared Function GlobalLock(ByVal hMem As IntPtr) As IntPtr
    End Function

    <DllImport("kernel32.dll", SetLastError:=True)> _
    Public Shared Function GlobalUnlock(ByVal hMem As IntPtr) As IntPtr
    End Function

    <DllImport("user32.dll", SetLastError:=True)> _
    Public Shared Function CloseClipboard() As Boolean
    End Function


    <DllImport("user32.dll", SetLastError:=True)> _
    Public Shared Function SetClipboardData(ByVal uFOrmat As UInteger, ByVal hMem As IntPtr) As IntPtr
    End Function


    <DllImport("user32.dll", SetLastError:=True)> _
    Public Shared Function EmptyClipboard() As Boolean
    End Function


    <DllImport("kernel32.dll", SetLastError:=True)> _
    Public Shared Function GlobalAlloc(ByVal uFlags As UInteger, ByVal dwBytes As UInteger) As IntPtr
    End Function

    <DllImport("kernel32.dll", CharSet:=CharSet.Ansi)> _
    Public Overloads Shared Sub CopyMemory(ByVal Destination As IntPtr, ByVal Source As Integer, ByVal Length As Integer)
    End Sub

    <DllImport("kernel32.dll", CharSet:=CharSet.Ansi)> _
    Public Overloads Shared Sub CopyMemory(ByVal Destination As IntPtr, ByVal Source As String, ByVal Length As Integer)
    End Sub


#End Region

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

        ' This incombination with  locking the Clipboard and calling PerformAction()
        ' will cause an exception.
        ugMain.DisplayLayout.Override.AllowMultiCellOperations = AllowMultiCellOperation.Paste

        ' Turning MultiCellOperations off will get rid of the exception.
        ' ugMain.DisplayLayout.Override.AllowMultiCellOperations = AllowMultiCellOperation.Default

        ultraDataSource1.Rows.Add(New Object() {#1/1/2000#, 1.45, True})
        ultraDataSource1.Rows.Add(New Object() {#2/1/2000#, 9.21, True})
    End Sub


#Region "Lock/Unlock Clipboard using API"


    Private Sub btnLockClipboard_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLockClipboard.Click

        Try


            If OpenClipboard(Me.Handle) Then

                EmptyClipboard()


                Dim hClipboardData As IntPtr = GlobalAlloc(GMEM_DDESHARE, CUInt(strToCopy.Length + 1))

                m_CBData = GlobalLock(hClipboardData)


                MessageBox.Show("Clipboard locked", "", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                MessageBox.Show("OpenClipboard returned false.")
            End If

        Catch ex As Exception
            MessageBox.Show("Error:  " & vbCrLf & ex.ToString, String.Empty, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    Private Sub btnUnlockClipboard_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUnlockClipboard.Click

        Try

            CopyMemory(m_CBData, strToCopy, strToCopy.Length)


            GlobalUnlock(m_CBData)

            SetClipboardData(CF_TEXT, m_CBData)

            CloseClipboard()

            MessageBox.Show("Clipboard unlocked.", String.Empty, MessageBoxButtons.OK, MessageBoxIcon.Information)

        Catch ex As Exception
            MessageBox.Show("Error:  " & vbCrLf & ex.ToString, "Error unlocking clipboard.", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try



    End Sub

#End Region

    Private Sub btnSelectGridRow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelectGridRow.Click

        Try


            ugMain.PerformAction(UltraGridAction.ToggleRowSel)

        Catch ex As Exception
            Trace.WriteLine(ex.ToString)
            MessageBox.Show(ex.ToString(), "Exception Occured in PerformAction", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

   
End Class
